Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/SelfTest/configuration/config-context_4-decod_unit_2-b.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/SelfTest/configuration/config-context_4-decod_unit_2-b.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/SelfTest/configuration/config-context_4-decod_unit_2-b.gen	(revision 145)
@@ -0,0 +1,71 @@
+Front_end
+4	4	+1	# nb_context                                                
+2	2	+1	# nb_decod_unit                                             
+32	32	+1	# size_general_data                                         
+4	4	+1	# size_ifetch_queue             [0] [nb_context]                
+8	8	+1	# size_ifetch_queue             [1] [nb_context]                
+32	32	+1	# size_ifetch_queue             [2] [nb_context]                
+8	8	+1	# size_ifetch_queue             [3] [nb_context]                
+4	4	+1	# nb_inst_fetch                 [0] [nb_context]                
+2	2	+1	# nb_inst_fetch                 [1] [nb_context]                
+16	16	+1	# nb_inst_fetch                 [2] [nb_context]                
+1	1	+1	# nb_inst_fetch                 [3] [nb_context]                
+1	1	+1	# link_context_to_decod_unit    [0] [nb_context]                
+0	0	+1	# link_context_to_decod_unit    [1] [nb_context]                
+1	1	+1	# link_context_to_decod_unit    [2] [nb_context]                
+1	1	+1	# link_context_to_decod_unit    [3] [nb_context]                
+4	4	+1	# size_decod_queue              [0] [nb_decod_unit]             
+12	12	+1	# size_decod_queue              [1] [nb_decod_unit]             
+0	0	+1	# decod_queue_scheme            [0] [nb_decod_unit]             
+1	1	+1	# decod_queue_scheme            [1] [nb_decod_unit]             
+2	2	+1	# nb_inst_decod                 [0] [nb_decod_unit]             
+6	6	+1	# nb_inst_decod                 [1] [nb_decod_unit]             
+1	1	+1	# nb_context_select             [0] [nb_decod_unit]             
+3	3	*3	# nb_context_select             [1] [nb_decod_unit]             
+1	1	+1	# context_select_priority       [0] [nb_decod_unit]             
+1	1	+1	# context_select_priority       [1] [nb_decod_unit]             
+1	1	+1	# context_select_load_balancing [0] [nb_decod_unit]             
+1	1	+1	# context_select_load_balancing [1] [nb_decod_unit]             
+1	1	+1	# nb_inst_branch_predict        
+2	2	+1	# nb_inst_branch_decod          
+2	2	+1	# nb_inst_branch_update         
+2	2	+1	# nb_inst_branch_complete       
+64	64	+1	# btb_size_queue                
+8	8	+1	# btb_associativity             
+2	2	+1	# btb_size_counter              
+3	3	+1	# btb_victim_scheme             
+1	1	+1	# dir_predictor_scheme          
+1	1	+1	# dir_have_bht                  [0] [3]                         
+1	1	+1	# dir_have_bht                  [1] [3]                         
+1	1	+1	# dir_have_bht                  [2] [3]                         
+1	1	+1	# dir_bht_size_shifter          [0] [3]                         
+1	1	+1	# dir_bht_size_shifter          [1] [3]                         
+1	1	+1	# dir_bht_size_shifter          [2] [3]                         
+1	1	+1	# dir_bht_nb_shifter            [0] [3]                         
+1	1	+1	# dir_bht_nb_shifter            [1] [3]                         
+1	1	+1	# dir_bht_nb_shifter            [2] [3]                         
+1	1	+1	# dir_have_pht                  [0] [3]                         
+1	1	+1	# dir_have_pht                  [1] [3]                         
+1	1	+1	# dir_have_pht                  [2] [3]                         
+1	1	+1	# dir_pht_size_counter          [0] [3]                         
+1	1	+1	# dir_pht_size_counter          [1] [3]                         
+1	1	+1	# dir_pht_size_counter          [2] [3]                         
+1	1	+1	# dir_pht_nb_counter            [0] [3]                         
+1	1	+1	# dir_pht_nb_counter            [1] [3]                         
+1	1	+1	# dir_pht_nb_counter            [2] [3]                         
+1	1	+1	# dir_pht_size_address_share    [0] [3]                         
+1	1	+1	# dir_pht_size_address_share    [1] [3]                         
+1	1	+1	# dir_pht_size_address_share    [2] [3]                         
+8       8       +1	# ras_size_queue                [0] [nb_context]                
+2       2       +1	# ras_size_queue                [1] [nb_context]                
+4       4       +1	# ras_size_queue                [2] [nb_context]                
+2       2       +1	# ras_size_queue                [3] [nb_context]                
+16	16	+1	# upt_size_queue                [0] [nb_context]                
+1	1	+1	# upt_size_queue                [1] [nb_context]                
+2	2	+1	# upt_size_queue                [2] [nb_context]                
+8	8	+1	# upt_size_queue                [3] [nb_context]                
+6  	6 	+1	# ufpt_size_queue               [0] [nb_context]                
+1	1	+1	# ufpt_size_queue               [1] [nb_context]                
+1	1	+1	# ufpt_size_queue               [2] [nb_context]                
+4	4	+1	# ufpt_size_queue               [3] [nb_context]                
+1	1	+1	# size_inst_commit
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/SelfTest/configuration/config-min.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/SelfTest/configuration/config-min.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/SelfTest/configuration/config-min.gen	(revision 145)
@@ -0,0 +1,47 @@
+Front_end
+1	1	+1	# nb_context                                                
+1	1	+1	# nb_decod_unit                                             
+32	32	+1	# size_general_data                                         
+1	1	+1	# size_ifetch_queue             [0] [nb_context]                
+1	1	+1	# nb_inst_fetch                 [0] [nb_context]                
+0	0	+1	# link_context_to_decod_unit    [0] [nb_context]                
+1	1	+1	# size_decod_queue              [0] [nb_decod_unit]             
+0	1	+1	# decod_queue_scheme            [0] [nb_decod_unit]             
+1	1	+1	# nb_inst_decod                 [0] [nb_decod_unit]             
+1	1	+1	# nb_context_select             [0] [nb_decod_unit]             
+1	1	+1	# context_select_priority       [0] [nb_decod_unit]             
+1	1	+1	# context_select_load_balancing [0] [nb_decod_unit]             
+1	1	+1	# nb_inst_branch_predict        
+1	1	+1	# nb_inst_branch_decod          
+1	1	+1	# nb_inst_branch_update         
+1	1	+1	# nb_inst_branch_complete       
+1	1	+1	# btb_size_queue                
+1	1	+1	# btb_associativity             
+2	2	+1	# btb_size_counter              
+1	1	+1	# btb_victim_scheme             
+1	1	+1	# dir_predictor_scheme          
+1	1	+1	# dir_have_bht                  [0] [3]                         
+1	1	+1	# dir_have_bht                  [1] [3]                         
+1	1	+1	# dir_have_bht                  [2] [3]                         
+1	1	+1	# dir_bht_size_shifter          [0] [3]                         
+1	1	+1	# dir_bht_size_shifter          [1] [3]                         
+1	1	+1	# dir_bht_size_shifter          [2] [3]                         
+1	1	+1	# dir_bht_nb_shifter            [0] [3]                         
+1	1	+1	# dir_bht_nb_shifter            [1] [3]                         
+1	1	+1	# dir_bht_nb_shifter            [2] [3]                         
+1	1	+1	# dir_have_pht                  [0] [3]                         
+1	1	+1	# dir_have_pht                  [1] [3]                         
+1	1	+1	# dir_have_pht                  [2] [3]                         
+1	1	+1	# dir_pht_size_counter          [0] [3]                         
+1	1	+1	# dir_pht_size_counter          [1] [3]                         
+1	1	+1	# dir_pht_size_counter          [2] [3]                         
+1	1	+1	# dir_pht_nb_counter            [0] [3]                         
+1	1	+1	# dir_pht_nb_counter            [1] [3]                         
+1	1	+1	# dir_pht_nb_counter            [2] [3]                         
+1	1	+1	# dir_pht_size_address_share    [0] [3]                         
+1	1	+1	# dir_pht_size_address_share    [1] [3]                         
+1	1	+1	# dir_pht_size_address_share    [2] [3]                         
+2       2       +1	# ras_size_queue                [0] [nb_context]                
+1	1	+1	# upt_size_queue                [0] [nb_context]                
+1	1	+1	# ufpt_size_queue               [0] [nb_context]                
+1	1	+1	# size_inst_commit 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/SelfTest/configuration/config_min.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/SelfTest/configuration/config_min.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/SelfTest/configuration/config_min.gen	(revision 145)
@@ -0,0 +1,21 @@
+Commit_unit
+1	1	+1	# nb_front_end            
+1	1	+1	# nb_context              [0]    [nb_front_end]
+1	1	+1	# nb_rename_unit          
+1	1	+1	# size_queue              
+1	1	+1	# nb_bank                 
+1	1	+1	# nb_inst_insert          [0]    [nb_rename_unit]
+1	1	+1	# nb_inst_retire	  [0]    [nb_rename_unit]
+1	1	+1	# nb_inst_commit
+1	1	+1	# nb_inst_reexecute	 
+1	1	+1	# nb_inst_branch_complete 
+0	0	+1	# nb_branch_speculated    [0][0] [nb_front_end][nb_context]
+1       1       +1      # size_nb_inst_decod
+32	32	+1	# size_general_data       
+1	1	+1	# size_store_queue_ptr    
+0	0	+1	# size_load_queue_ptr     
+5	5	+1	# size_general_register   
+1	1	+1	# size_special_register   
+1	1	+1	# priority              
+1	1	+1	# load_balancing        
+1	1	+1	# nb_rename_unit_select 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/SelfTest/configuration/config_mono_rename_unit.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/SelfTest/configuration/config_mono_rename_unit.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/SelfTest/configuration/config_mono_rename_unit.gen	(revision 145)
@@ -0,0 +1,21 @@
+Commit_unit
+1	1	+1	# nb_front_end            
+1	1	+1	# nb_context              [0]    [nb_front_end]
+1	1	+1	# nb_rename_unit          
+64 	64	*2	# size_queue              
+4	8 	*2	# nb_bank                 
+1	4	*4	# nb_inst_insert          [0]    [nb_rename_unit]
+1	4	*4	# nb_inst_retire	  [0]    [nb_rename_unit]
+1	4	*4	# nb_inst_commit
+1	1	+1	# nb_inst_reexecute	 
+1	1	+1	# nb_inst_branch_complete 
+0	0	+1	# nb_branch_speculated    [0][0] [nb_front_end][nb_context]
+1       1       +1      # size_nb_inst_decod
+32	32	+1	# size_general_data       
+1	1	+1	# size_store_queue_ptr    
+0	0	+1	# size_load_queue_ptr     
+5	5	+1	# size_general_register   
+1	1	+1	# size_special_register   
+1	1	+1	# priority              
+1	1	+1	# load_balancing        
+1	1	+1	# nb_rename_unit_select 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Commit_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Commit_unit.h	(revision 144)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Commit_unit.h	(revision 145)
@@ -74,5 +74,5 @@
   public    : counter_t                     ** _stat_nb_cycle_state_wait_end      ;//[nb_thread]
 
-// public    : uint32_t                       * _stat_last_inst                    ;//[nb_thread]
+//public    : uint32_t                       * _stat_last_inst                    ;//[nb_thread]
   public    : uint32_t                       * _stat_last_inst_type               ;//[nb_thread]
   public    : uint32_t                       * _stat_last_inst_operation          ;//[nb_thread]
@@ -97,4 +97,5 @@
 //public    : SC_IN (Tcontext_t         ) ***  in_INSERT_RENAME_UNIT_ID            ;//[nb_rename_unit][nb_inst_insert]
   public    : SC_IN (Tdepth_t           ) ***  in_INSERT_DEPTH                     ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tcontrol_t         ) ***  in_INSERT_SAVE_RAT                  ;//[nb_rename_unit][nb_inst_insert]
 #ifdef STATISTICS
   public    : SC_IN (uint32_t           ) ***  in_INSERT_INSTRUCTION               ;//[nb_rename_unit][nb_inst_insert]
@@ -141,4 +142,5 @@
   public    : SC_OUT(Tcontext_t         ) *** out_RETIRE_CONTEXT_ID                ;//[nb_rename_unit][nb_inst_retire]
 //public    : SC_OUT(Tcontext_t         ) *** out_RETIRE_RENAME_UNIT_ID            ;//[nb_rename_unit][nb_inst_retire]
+//public    : SC_OUT(Tdepth_t           ) *** out_RETIRE_DEPTH                     ;//[nb_rename_unit][nb_inst_retire]
   public    : SC_OUT(Tcontrol_t         ) *** out_RETIRE_USE_STORE_QUEUE           ;//[nb_rename_unit][nb_inst_retire]
   public    : SC_OUT(Tcontrol_t         ) *** out_RETIRE_USE_LOAD_QUEUE            ;//[nb_rename_unit][nb_inst_retire]
@@ -234,8 +236,8 @@
   public    : SC_IN (Tcounter_t         ) ***  in_NB_INST_DECOD_ALL                ;//[nb_front_end][nb_context]
 										   
-    // ~~~~~[ Interface : "depth" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~	   
-  public    : SC_IN (Tdepth_t           ) ***  in_DEPTH_MIN                        ;//[nb_front_end][nb_context]
-  public    : SC_IN (Tdepth_t           ) ***  in_DEPTH_MAX                        ;//[nb_front_end][nb_context]
-  public    : SC_IN (Tcontrol_t         ) ***  in_DEPTH_FULL                       ;//[nb_front_end][nb_context]
+//  // ~~~~~[ Interface : "depth" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~	   
+//public    : SC_IN (Tdepth_t           ) ***  in_DEPTH_MIN                        ;//[nb_front_end][nb_context]
+//public    : SC_IN (Tdepth_t           ) ***  in_DEPTH_MAX                        ;//[nb_front_end][nb_context]
+//public    : SC_IN (Tcontrol_t         ) ***  in_DEPTH_FULL                       ;//[nb_front_end][nb_context]
 
     // ~~~~~[ Interface : "spr_read" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -272,4 +274,5 @@
   private   : Tcounter_t                   ** reg_NB_INST_COMMIT_ALL               ;//[nb_front_end][nb_context]
   private   : Tcounter_t                   ** reg_NB_INST_COMMIT_MEM               ;//[nb_front_end][nb_context]
+  private   : Tcounter_t                  *** reg_NB_INST_DEPTH                    ;//[nb_front_end][nb_context][nb_branch_speculated]
 
   private   : Tcommit_event_state_t        ** reg_EVENT_STATE                      ;//[nb_front_end][nb_context]
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Parameters.h	(revision 144)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Parameters.h	(revision 145)
@@ -24,46 +24,49 @@
   {
     //-----[ fields ]------------------------------------------------------------
-  public : uint32_t             _nb_front_end                       ;
-  public : uint32_t           * _nb_context                         ;//[nb_front_end]
-  public : uint32_t             _nb_rename_unit                     ;
-  public : uint32_t             _size_queue                         ;
-  public : uint32_t             _nb_bank                            ;
-  public : Tretire_ooo_scheme_t _retire_ooo_scheme                  ;
-  public : uint32_t           * _nb_inst_insert                     ;//[nb_rename_unit]
-  public : uint32_t           * _nb_inst_retire	                    ;//[nb_rename_unit]
-  public : uint32_t             _nb_inst_commit                     ;
-  public : uint32_t             _nb_inst_reexecute                  ;
-  public : uint32_t             _nb_inst_branch_complete            ;
-  public : uint32_t          ** _nb_branch_speculated               ;//[nb_front_end][nb_context]
-//public : uint32_t             _size_general_data                  ;
-//public : uint32_t             _size_store_queue_ptr               ;
-//public : uint32_t             _size_load_queue_ptr                ;
-//public : uint32_t             _size_general_register              ;
-//public : uint32_t             _size_special_register              ;
-  public : Trat_scheme_t      * _rat_scheme                         ;//[nb_front_end]
-  public : Tpriority_t          _priority                           ;
-  public : Tload_balancing_t    _load_balancing                     ;
-  public : uint32_t             _nb_rename_unit_select              ;
-  public : uint32_t             _nb_thread                          ;
-  public : uint32_t          ** _translate_num_context_to_num_thread;//[nb_front_end][nb_context]
-  public : const uint32_t       _nb_bank_access_commit              ;
+  public : uint32_t               _nb_front_end                       ;
+  public : uint32_t             * _nb_context                         ;//[nb_front_end]
+  public : uint32_t               _nb_rename_unit                     ;
+  public : uint32_t               _size_queue                         ;
+  public : uint32_t               _nb_bank                            ;
+  public : Tretire_ooo_scheme_t   _retire_ooo_scheme                  ;
+  public : uint32_t             * _nb_inst_insert                     ;//[nb_rename_unit]
+  public : uint32_t             * _nb_inst_retire	                    ;//[nb_rename_unit]
+  public : uint32_t               _nb_inst_commit                     ;
+  public : uint32_t               _nb_inst_reexecute                  ;
+  public : uint32_t               _nb_inst_branch_complete            ;
+  public : uint32_t            ** _nb_branch_speculated               ;//[nb_front_end][nb_context]
+//public : uint32_t               _size_general_data                  ;
+//public : uint32_t               _size_store_queue_ptr               ;
+//public : uint32_t               _size_load_queue_ptr                ;
+//public : uint32_t               _size_general_register              ;
+//public : uint32_t               _size_special_register              ;
+  public : Trat_scheme_t        * _rat_scheme                         ;//[nb_rename_unit]
+  public : std::vector<uint32_t>* _link_front_end_with_rename_unit    ;//[nb_rename_unit]
 
-  public : uint32_t             _max_nb_context          ;
-  public : uint32_t             _max_nb_inst_insert      ;
-  public : uint32_t             _max_nb_inst_retire      ;
-//public : uint32_t             _size_address            ;
-//public : uint32_t             _size_front_end_id       ;
-//public : uint32_t             _size_context_id         ;
-  public : uint32_t             _size_rename_unit_id     ;    
-  public : uint32_t             _size_bank               ;
-//public : uint32_t             _size_nb_inst            ;
-//public : uint32_t             _size_packet_id          ;
-  public : uint32_t          ** _array_size_depth        ;//[nb_front_end][nb_context]
-//public : uint32_t             _max_size_depth          ;
-                             
-//public : Tpacket_t            _shift_num_bank          ;
-  public : Tpacket_t            _mask_num_bank           ;
-  public : Tpacket_t            _shift_num_slot          ;
-//public : Tpacket_t            _mask_num_slot           ;
+  public : Tpriority_t            _priority                           ;
+  public : Tload_balancing_t      _load_balancing                     ;
+  public : uint32_t               _nb_rename_unit_select              ;
+  public : uint32_t               _nb_thread                          ;
+  public : uint32_t            ** _translate_num_context_to_num_thread;//[nb_front_end][nb_context]
+  public : Trat_scheme_t        * _front_end_rat_scheme               ;//[nb_front_end]
+  public : const uint32_t         _nb_bank_access_commit              ;
+                               
+  public : uint32_t               _max_nb_context          ;
+  public : uint32_t               _max_nb_inst_insert      ;
+  public : uint32_t               _max_nb_inst_retire      ;
+//public : uint32_t               _size_address            ;
+//public : uint32_t               _size_front_end_id       ;
+//public : uint32_t               _size_context_id         ;
+  public : uint32_t               _size_rename_unit_id     ;    
+  public : uint32_t               _size_bank               ;
+//public : uint32_t               _size_nb_inst            ;
+//public : uint32_t               _size_packet_id          ;
+  public : uint32_t            ** _array_size_depth        ;//[nb_front_end][nb_context]
+//public : uint32_t               _max_size_depth          ;
+                               
+//public : Tpacket_t              _shift_num_bank          ;
+  public : Tpacket_t              _mask_num_bank           ;
+  public : Tpacket_t              _shift_num_slot          ;
+//public : Tpacket_t              _mask_num_slot           ;
                              
                              
@@ -79,29 +82,30 @@
 
     //-----[ methods ]-----------------------------------------------------------
-  public : Parameters  (uint32_t             nb_front_end                       ,
-			uint32_t           * nb_context                         ,//[nb_front_end]
-			uint32_t             nb_rename_unit                     ,
-			uint32_t             size_queue                         ,
-			uint32_t             nb_bank                            ,
-                        Tretire_ooo_scheme_t retire_ooo_scheme                  ,
-			uint32_t           * nb_inst_insert                     ,//[nb_rename_unit]
-			uint32_t           * nb_inst_retire                     ,//[nb_rename_unit]
-			uint32_t             nb_inst_commit                     ,
-			uint32_t             nb_inst_reexecute                  ,
-			uint32_t             nb_inst_branch_complete            ,
-			uint32_t          ** nb_branch_speculated               ,//[nb_front_end][nb_context]
-                        uint32_t             size_nb_inst_decod                 ,
-			uint32_t             size_general_data                  ,
-			uint32_t             size_store_queue_ptr               ,
-			uint32_t             size_load_queue_ptr                ,
-			uint32_t             size_general_register              ,
-			uint32_t             size_special_register              ,
-                        Trat_scheme_t      * rat_scheme                         ,//[nb_front_end]
-			Tpriority_t          priority                           ,
-			Tload_balancing_t    load_balancing                     ,
-			uint32_t             nb_rename_unit_select              ,
-                        uint32_t             nb_thread                          ,
-                        uint32_t          ** translate_num_context_to_num_thread, //[nb_front_end][nb_context]
-                        bool                 is_toplevel=false
+  public : Parameters  (uint32_t               nb_front_end                       ,
+			uint32_t             * nb_context                         ,//[nb_front_end]
+			uint32_t               nb_rename_unit                     ,
+			uint32_t               size_queue                         ,
+			uint32_t               nb_bank                            ,
+                        Tretire_ooo_scheme_t   retire_ooo_scheme                  ,
+			uint32_t             * nb_inst_insert                     ,//[nb_rename_unit]
+			uint32_t             * nb_inst_retire                     ,//[nb_rename_unit]
+			uint32_t               nb_inst_commit                     ,
+			uint32_t               nb_inst_reexecute                  ,
+			uint32_t               nb_inst_branch_complete            ,
+			uint32_t            ** nb_branch_speculated               ,//[nb_front_end][nb_context]
+                        uint32_t               size_nb_inst_decod                 ,
+			uint32_t               size_general_data                  ,
+			uint32_t               size_store_queue_ptr               ,
+			uint32_t               size_load_queue_ptr                ,
+			uint32_t               size_general_register              ,
+			uint32_t               size_special_register              ,
+                        Trat_scheme_t        * rat_scheme                         ,//[nb_rename_unit]
+                        std::vector<uint32_t>* link_front_end_with_rename_unit    ,//[nb_rename_unit]
+                        Tpriority_t            priority                           ,
+			Tload_balancing_t      load_balancing                     ,
+			uint32_t               nb_rename_unit_select              ,
+                        uint32_t               nb_thread                          ,
+                        uint32_t            ** translate_num_context_to_num_thread, //[nb_front_end][nb_context]
+                        bool                   is_toplevel=false
 			);
 //   public : Parameters  (Parameters & param) ;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Types.h	(revision 144)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/include/Types.h	(revision 145)
@@ -81,4 +81,6 @@
   public  : rob_state_t        state                   ;
   public  : rob_state_t        state_old               ;
+//public  : Tcontrol_t         restore                 ;
+
   public  : uint32_t           ptr                     ;
   public  : Tcontext_t         front_end_id            ;
@@ -207,4 +209,20 @@
   };
 
+  template<> inline std::string toString<morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::Tcommit_event_state_t>(const morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::Tcommit_event_state_t& x)
+  {
+    switch (x)
+      {
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::COMMIT_EVENT_STATE_NO_EVENT      : return "COMMIT_EVENT_STATE_NO_EVENT"     ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::COMMIT_EVENT_STATE_NOT_YET_EVENT : return "COMMIT_EVENT_STATE_NOT_YET_EVENT"; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::COMMIT_EVENT_STATE_EVENT         : return "COMMIT_EVENT_STATE_EVENT"        ; break;
+//    case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::COMMIT_EVENT_STATE_WAIT_DECOD    : return "COMMIT_EVENT_STATE_WAIT_DECOD"   ; break;
+      case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::COMMIT_EVENT_STATE_WAIT_END      : return "COMMIT_EVENT_STATE_WAIT_END"     ; break;
+//    case morpheo::behavioural::core::multi_ooo_engine::ooo_engine::commit_unit::COMMIT_EVENT_STATE_END           : return "COMMIT_EVENT_STATE_END"          ; break;
+
+      default    : return ""      ; break;
+      }
+  };
+
+
 }; // end namespace morpheo              
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit.cpp	(revision 144)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Commit_unit/src/Commit_unit.cpp	(revision 145)
@@ -115,4 +115,19 @@
 	sensitive << (*(in_CLOCK)).neg() // need internal register
 		  << (*(in_NRESET));
+
+        for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
+          if (_param->_rat_scheme[i] == RAT_DEPTH_SAVE)
+            for (uint32_t j=0; j<_param->_nb_inst_insert[i]; j++)
+              {
+                if (_param->_have_port_front_end_id  )
+                sensitive << (*(in_INSERT_FRONT_END_ID [i][j]));
+                if (_param->_have_port_context_id  )
+                sensitive << (*(in_INSERT_CONTEXT_ID   [i][j]));
+                if (_param->_have_port_depth)
+                sensitive << (*(in_INSERT_DEPTH        [i][j]));
+                sensitive << (*(in_INSERT_SAVE_RAT     [i][j]));
+              }
+
+
 // 	for (uint32_t i=0; i<_param->_nb_rename_unit; i++)
 // 	  for (uint32_t j=0; j<_param->_nb_inst_insert[i]; j++)
